glibmm: Gio::TlsConnection Class Reference

glibmm 2.62.0

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Functions | List of all members
Gio::TlsConnection Class Reference

TlsConnection - TLS connection type. More...

`#include <giomm/tlsconnection.h>`

Inheritance diagram for Gio::TlsConnection:
[legend]

## Public Member Functions
| TlsConnection (TlsConnection&& src) noexcept
TlsConnection& | operator= (TlsConnection&& src) noexcept
| ~TlsConnection () noexcept override
GTlsConnection* | gobj ()
| Provides access to the underlying C GObject. More...
const GTlsConnection* | gobj () const
| Provides access to the underlying C GObject. More...
GTlsConnection* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
void | set_certificate (const Glib::RefPtr< TlsCertificate >& certificate)
| This sets the certificate that conn will present to its peer during the TLS handshake. More...
Glib::RefPtr< TlsCertificate > | get_certificate ()
| Gets conn's certificate, as set by g_tls_connection_set_certificate(). More...
Glib::RefPtr< const TlsCertificate > | get_certificate () const
| Gets conn's certificate, as set by g_tls_connection_set_certificate(). More...
Glib::RefPtr< TlsCertificate > | get_peer_certificate ()
| Gets conn's peer's certificate after the handshake has completed. More...
Glib::RefPtr< const TlsCertificate > | get_peer_certificate () const
| Gets conn's peer's certificate after the handshake has completed. More...
TlsCertificateFlags | get_peer_certificate_errors () const
| Gets the errors associated with validating conn's peer's certificate, after the handshake has completed. More...
void | set_require_close_notify (bool require_close_notify=true)
| Sets whether or not conn expects a proper TLS close notification before the connection is closed. More...
bool | get_require_close_notify () const
| Tests whether or not conn expects a proper TLS close notification when the connection is closed. More...
void | set_rehandshake_mode (TlsRehandshakeMode mode)
| Sets how conn behaves with respect to rehandshaking requests, when TLS 1.2 or older is in use. More...
TlsRehandshakeMode | get_rehandshake_mode () const
| Gets conn rehandshaking mode. More...
void | set_use_system_certdb (bool use_system_certdb=true)
| Sets whether conn uses the system certificate database to verify peer certificates. More...
bool | get_use_system_certdb () const
| Gets whether conn uses the system certificate database to verify peer certificates. More...
Glib::RefPtr< TlsDatabase > | get_database ()
| Gets the certificate database that conn uses to verify peer certificates. More...
Glib::RefPtr< const TlsDatabase > | get_database () const
| Gets the certificate database that conn uses to verify peer certificates. More...
void | set_database (const Glib::RefPtr< TlsDatabase >& database)
| Sets the certificate database that is used to verify peer certificates. More...
Glib::RefPtr< TlsInteraction > | get_interaction ()
| Get the object that will be used to interact with the user. More...
Glib::RefPtr< const TlsInteraction > | get_interaction () const
| Get the object that will be used to interact with the user. More...
void | set_interaction (const Glib::RefPtr< TlsInteraction >& interaction)
| Set the object that will be used to interact with the user. More...
bool | handshake (const Glib::RefPtr< Cancellable >& cancellable)
| Attempts a TLS handshake on conn. More...
bool | handshake ()
| A handshake() convenience overload. More...
void | handshake_async (const SlotAsyncReady& slot, const Glib::RefPtr< Cancellable >& cancellable, int io_priority=Glib::PRIORITY_DEFAULT)
| Asynchronously performs a TLS handshake on conn. More...
void | handshake_async (const SlotAsyncReady& slot, int io_priority=Glib::PRIORITY_DEFAULT)
| A handshake_async() convenience overload. More...
bool | handshake_finish (const Glib::RefPtr< AsyncResult >& result)
| Finish an asynchronous TLS handshake operation. More...
bool | emit_accept_certificate (const Glib::RefPtr< const TlsCertificate >& peer_cert, TlsCertificateFlags errors)
| Used by TlsConnection implementations to emit the TlsConnection::signal_accept_certificate() signal. More...
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< IOStream > > | property_base_io_stream () const
| The IOStream that the connection wraps. More...
Glib::PropertyProxy< Glib::RefPtr< TlsCertificate > > | property_certificate ()
| The connection's certificate; see g_tls_connection_set_certificate(). More...
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< TlsCertificate > > | property_certificate () const
| The connection's certificate; see g_tls_connection_set_certificate(). More...
Glib::PropertyProxy< Glib::RefPtr< TlsDatabase > > | property_database ()
| The certificate database to use when verifying this TLS connection. More...
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< TlsDatabase > > | property_database () const
| The certificate database to use when verifying this TLS connection. More...
Glib::PropertyProxy< Glib::RefPtr< TlsInteraction > > | property_interaction ()
| A TlsInteraction object to be used when the connection or certificate database need to interact with the user. More...
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< TlsInteraction > > | property_interaction () const
| A TlsInteraction object to be used when the connection or certificate database need to interact with the user. More...
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< TlsCertificate > > | property_peer_certificate () const
| The connection's peer's certificate, after the TLS handshake has completed and the certificate has been accepted. More...
Glib::PropertyProxy_ReadOnly< TlsCertificateFlags > | property_peer_certificate_errors () const
| The errors noticed-and-ignored while verifying TlsConnection::property_peer_certificate(). More...
Glib::PropertyProxy< TlsRehandshakeMode > | property_rehandshake_mode ()
| The rehandshaking mode. More...
Glib::PropertyProxy_ReadOnly< TlsRehandshakeMode > | property_rehandshake_mode () const
| The rehandshaking mode. More...
Glib::PropertyProxy< bool > | property_require_close_notify ()
| Whether or not proper TLS close notification is required. More...
Glib::PropertyProxy_ReadOnly< bool > | property_require_close_notify () const
| Whether or not proper TLS close notification is required. More...
Glib::PropertyProxy< bool > | property_use_system_certdb ()
| Whether or not the system certificate database will be used to verify peer certificates. More...
Glib::PropertyProxy_ReadOnly< bool > | property_use_system_certdb () const
| Whether or not the system certificate database will be used to verify peer certificates. More...
Glib::SignalProxy< bool, const Glib::RefPtr< const TlsCertificate >&, TlsCertificateFlags > | signal_accept_certificate ()
virtual bool | handshake_vfunc (const Glib::RefPtr< Cancellable >& cancellable)
virtual void | handshake_async_vfunc (const SlotAsyncReady& slot, const Glib::RefPtr< Cancellable >& cancellable, int io_priority)
virtual bool | handshake_finish_vfunc (const Glib::RefPtr< AsyncResult >& result)
Public Member Functions inherited from Gio::IOStream
| IOStream (IOStream&& src) noexcept
IOStream& | operator= (IOStream&& src) noexcept
| ~IOStream () noexcept override
GIOStream* | gobj ()
| Provides access to the underlying C GObject. More...
const GIOStream* | gobj () const
| Provides access to the underlying C GObject. More...
GIOStream* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
void | splice_async (const Glib::RefPtr< IOStream >& stream2, const SlotAsyncReady& slot, const Glib::RefPtr< Cancellable >& cancellable, IOStreamSpliceFlags flags=Gio::IO_STREAM_SPLICE_NONE, int io_priority=Glib::PRIORITY_DEFAULT)
| Asyncronously splice the output stream to the input stream of stream2, and splice the output stream of stream2 to the input stream of this stream. More...
void | splice_async (const Glib::RefPtr< IOStream >& stream2, const SlotAsyncReady& slot, IOStreamSpliceFlags flags=Gio::IO_STREAM_SPLICE_NONE, int io_priority=Glib::PRIORITY_DEFAULT)
| A non-cancellable version of splice_async(). More...
Glib::RefPtr< InputStream > | get_input_stream ()
| Gets the input stream for this object. More...
Glib::RefPtr< OutputStream > | get_output_stream ()
| Gets the output stream for this object. More...
bool | close (const Glib::RefPtr< Cancellable >& cancellable)
| Closes the stream, releasing resources related to it. More...
bool | close ()
| A close() convenience overload. More...
void | close_async (const SlotAsyncReady& slot, const Glib::RefPtr< Cancellable >& cancellable, int io_priority=Glib::PRIORITY_DEFAULT)
void | close_async (const SlotAsyncReady& slot, int io_priority=Glib::PRIORITY_DEFAULT)
bool | close_finish (const Glib::RefPtr< AsyncResult >& result)
| Closes a stream. More...
bool | is_closed () const
| Checks if a stream is closed. More...
bool | has_pending () const
| Checks if a stream has pending actions. More...
bool | set_pending ()
| Sets stream to have actions pending. More...
void | clear_pending ()
| Clears the pending flag on stream. More...
Public Member Functions inherited from Glib::Object
| Object (const Object&)=delete
Object& | operator= (const Object&)=delete
| Object (Object&& src) noexcept
Object& | operator= (Object&& src) noexcept
void* | get_data (const QueryQuark& key)
void | set_data (const Quark& key, void* data)
void | set_data (const Quark& key, void* data, DestroyNotify notify)
void | remove_data (const QueryQuark& quark)
void* | steal_data (const QueryQuark& quark)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase&)=delete
ObjectBase& | operator= (const ObjectBase&)=delete
void | set_property_value (const Glib::ustring& property_name, const Glib::ValueBase& value)
| You probably want to use a specific property_*() accessor method instead. More...
void | get_property_value (const Glib::ustring& property_name, Glib::ValueBase& value) const
| You probably want to use a specific property_*() accessor method instead. More...
template<class PropertyType >
void | set_property (const Glib::ustring& property_name, const PropertyType& value)
| You probably want to use a specific property_*() accessor method instead. More...
template<class PropertyType >
void | get_property (const Glib::ustring& property_name, PropertyType& value) const
| You probably want to use a specific property_*() accessor method instead. More...
void | connect_property_changed (const Glib::ustring& property_name, const sigc::slot< void >& slot)
| You can use the signal_changed() signal of the property proxy instead. More...
void | connect_property_changed (const Glib::ustring& property_name, sigc::slot< void >&& slot)
| You can use the signal_changed() signal of the property proxy instead. More...
sigc::connection | connect_property_changed_with_return (const Glib::ustring& property_name, const sigc::slot< void >& slot)
| You can use the signal_changed() signal of the property proxy instead. More...
sigc::connection | connect_property_changed_with_return (const Glib::ustring& property_name, sigc::slot< void >&& slot)
| You can use the signal_changed() signal of the property proxy instead. More...
void | freeze_notify ()
| Increases the freeze count on object. More...
void | thaw_notify ()
| Reverts the effect of a previous call to freeze_notify(). More...
virtual void | reference () const
| Increment the reference count for this object. More...
virtual void | unreference () const
| Decrement the reference count for this object. More...
GObject* | gobj ()
| Provides access to the underlying C GObject. More...
const GObject* | gobj () const
| Provides access to the underlying C GObject. More...
GObject* | gobj_copy () const
| Give a ref-ed copy to someone. Use for direct struct access. More...
Public Member Functions inherited from sigc::trackable
| trackable () noexcept
| trackable (const trackable &src) noexcept
| trackable (trackable &&src)
| ~trackable ()
void | add_destroy_notify_callback (void *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
trackable & | operator= (trackable &&src)
void | remove_destroy_notify_callback (void *data) const

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
Static Public Member Functions inherited from Gio::IOStream
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
static bool | splice_finish (const Glib::RefPtr< AsyncResult >& result)
| Finishes an asynchronous io stream splice operation. More...

## Protected Member Functions
| TlsConnection ()
virtual bool | on_accept_certificate (const Glib::RefPtr< const TlsCertificate >& peer_cert, TlsCertificateFlags errors)
| This is a default handler for the signal signal_accept_certificate(). More...
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams& construct_params)
| Object (GObject* castitem)
| ~Object () noexcept override
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| This default constructor is called implicitly from the constructor of user-derived classes, even if, for instance, Gtk::Button calls a different ObjectBase constructor. More...
| ObjectBase (const char* custom_type_name)
| A derived constructor always overrides this choice. More...
| ObjectBase (const std::type_info& custom_type_info)
| This constructor is a special feature to allow creation of derived types on the fly, without having to use g_object_new() manually. More...
| ObjectBase (ObjectBase&& src) noexcept
ObjectBase& | operator= (ObjectBase&& src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject* castitem)
void | initialize_move (GObject* castitem, Glib::ObjectBase* previous_wrapper)

## Related Functions
(Note that these are not member functions.)
Glib::RefPtr< Gio::TlsConnection > | wrap (GTlsConnection* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Gio::IOStream
Glib::RefPtr< Gio::IOStream > | wrap (GIOStream* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Glib::Object
Glib::RefPtr< Glib::Object > | wrap (GObject* object, bool take_copy=false)

## Additional Inherited Members
Public Types inherited from Glib::Object
using | DestroyNotify = void(*)(gpointer data)
Public Types inherited from sigc::trackable
typedef internal::func_destroy_notify | func_destroy_notify

## Detailed Description

TlsConnection - TLS connection type.

TlsConnection is the base TLS connection class type, which wraps an IOStream and provides TLS encryption on top of it. Its subclasses, TlsClientConnection and TlsServerConnection, implement client-side and server-side TLS, respectively.

Since glibmm 2.36:

## Constructor & Destructor Documentation

## ◆ TlsConnection() [1/2]

Gio::TlsConnection::TlsConnection | ( | TlsConnection&& | src | ) |
| noexcept

## ◆ ~TlsConnection()

Gio::TlsConnection::~TlsConnection | ( |  | ) |
| overridenoexcept

## ◆ TlsConnection() [2/2]

Gio::TlsConnection::TlsConnection | ( |  | ) |
| protected

## Member Function Documentation

## ◆ emit_accept_certificate()

bool Gio::TlsConnection::emit_accept_certificate | ( | const Glib::RefPtr< const TlsCertificate >& | peer_cert,
|  | TlsCertificateFlags | errors
| ) |  |

Used by TlsConnection implementations to emit the TlsConnection::signal_accept_certificate() signal.

Since glibmm 2.28:

Parameters

  peer_cert | The peer's TlsCertificate.
  errors | The problems with peer_cert.

Returns
  `true` if one of the signal handlers has returned `true` to accept peer_cert.

## ◆ get_certificate() [1/2]

Glib::RefPtr<TlsCertificate> Gio::TlsConnection::get_certificate | ( |  | ) |

Gets conn's certificate, as set by g_tls_connection_set_certificate().

Since glibmm 2.28:

Returns
  conn's certificate, or `nullptr`.

## ◆ get_certificate() [2/2]

Glib::RefPtr<const TlsCertificate> Gio::TlsConnection::get_certificate | ( |  | ) | const

Gets conn's certificate, as set by g_tls_connection_set_certificate().

Since glibmm 2.28:

Returns
  conn's certificate, or `nullptr`.

## ◆ get_database() [1/2]

Glib::RefPtr<TlsDatabase> Gio::TlsConnection::get_database | ( |  | ) |

Gets the certificate database that conn uses to verify peer certificates.

See g_tls_connection_set_database().

Since glibmm 2.30:

Returns
  The certificate database that conn uses or `nullptr`.

## ◆ get_database() [2/2]

Glib::RefPtr<const TlsDatabase> Gio::TlsConnection::get_database | ( |  | ) | const

Gets the certificate database that conn uses to verify peer certificates.

See g_tls_connection_set_database().

Since glibmm 2.30:

Returns
  The certificate database that conn uses or `nullptr`.

## ◆ get_interaction() [1/2]

Glib::RefPtr<TlsInteraction> Gio::TlsConnection::get_interaction | ( |  | ) |

Get the object that will be used to interact with the user.

It will be used for things like prompting the user for passwords. If `nullptr` is returned, then no user interaction will occur for this connection.

Since glibmm 2.30:

Returns
  The interaction object.

## ◆ get_interaction() [2/2]

Glib::RefPtr<const TlsInteraction> Gio::TlsConnection::get_interaction | ( |  | ) | const

Get the object that will be used to interact with the user.

It will be used for things like prompting the user for passwords. If `nullptr` is returned, then no user interaction will occur for this connection.

Since glibmm 2.30:

Returns
  The interaction object.

## ◆ get_peer_certificate() [1/2]

Glib::RefPtr<TlsCertificate> Gio::TlsConnection::get_peer_certificate | ( |  | ) |

Gets conn's peer's certificate after the handshake has completed.

(It is not set during the emission of TlsConnection::signal_accept_certificate().)

Since glibmm 2.28:

Returns
  conn's peer's certificate, or `nullptr`.

## ◆ get_peer_certificate() [2/2]

Glib::RefPtr<const TlsCertificate> Gio::TlsConnection::get_peer_certificate | ( |  | ) | const

Gets conn's peer's certificate after the handshake has completed.

(It is not set during the emission of TlsConnection::signal_accept_certificate().)

Since glibmm 2.28:

Returns
  conn's peer's certificate, or `nullptr`.

## ◆ get_peer_certificate_errors()

TlsCertificateFlags Gio::TlsConnection::get_peer_certificate_errors | ( |  | ) | const

Gets the errors associated with validating conn's peer's certificate, after the handshake has completed.

(It is not set during the emission of TlsConnection::signal_accept_certificate().)

Since glibmm 2.28:

Returns
  conn's peer's certificate errors.

## ◆ get_rehandshake_mode()

TlsRehandshakeMode Gio::TlsConnection::get_rehandshake_mode | ( |  | ) | const

Gets conn rehandshaking mode.

See g_tls_connection_set_rehandshake_mode() for details.

Since glibmm 2.28:

Deprecated: 2.60. Changing the rehandshake mode is no longer required for compatibility. Also, rehandshaking has been removed from the TLS protocol in TLS 1.3.

Deprecated:
  Changing the rehandshake mode is no longer required for compatibility. Also, rehandshaking has been removed from the TLS protocol in TLS 1.3.

Returns
  conn's rehandshaking mode.

## ◆ get_require_close_notify()

bool Gio::TlsConnection::get_require_close_notify | ( |  | ) | const

Tests whether or not conn expects a proper TLS close notification when the connection is closed.

See g_tls_connection_set_require_close_notify() for details.

Since glibmm 2.28:

Returns
  `true` if conn requires a proper TLS close notification.

## ◆ get_type()

static GType Gio::TlsConnection::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

## ◆ get_use_system_certdb()

bool Gio::TlsConnection::get_use_system_certdb | ( |  | ) | const

Gets whether conn uses the system certificate database to verify peer certificates.

See g_tls_connection_set_use_system_certdb().

Deprecated: 2.30: Use g_tls_connection_get_database() instead

Deprecated:
  Use get_database() instead.

Returns
  Whether conn uses the system certificate database.

## ◆ gobj() [1/2]

GTlsConnection* Gio::TlsConnection::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

## ◆ gobj() [2/2]

const GTlsConnection* Gio::TlsConnection::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

## ◆ gobj_copy()

GTlsConnection* Gio::TlsConnection::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

## ◆ handshake() [1/2]

bool Gio::TlsConnection::handshake | ( |  | ) |

A handshake() convenience overload.

## ◆ handshake() [2/2]

bool Gio::TlsConnection::handshake | ( | const Glib::RefPtr< Cancellable >& | cancellable | ) |

Attempts a TLS handshake on conn.

On the client side, it is never necessary to call this method; although the connection needs to perform a handshake after connecting (or after sending a "STARTTLS"-type command) and may need to rehandshake later if the server requests it, TlsConnection will handle this for you automatically when you try to send or receive data on the connection. However, you can call g_tls_connection_handshake() manually if you want to know for sure whether the initial handshake succeeded or failed (as opposed to just immediately trying to write to conn's output stream, in which case if it fails, it may not be possible to tell if it failed before or after completing the handshake).

Likewise, on the server side, although a handshake is necessary at the beginning of the communication, you do not need to call this function explicitly unless you want clearer error reporting.

If TLS 1.2 or older is in use, you may call g_tls_connection_handshake() after the initial handshake to rehandshake; however, this usage is deprecated because rehandshaking is no longer part of the TLS protocol in TLS 1.3. Accordingly, the behavior of calling this function after the initial handshake is now undefined, except it is guaranteed to be reasonable and nondestructive so as to preserve compatibility with code written for older versions of GLib.

TlsConnection::accept_certificate may be emitted during the handshake.

Since glibmm 2.28:

Parameters

  cancellable | A Cancellable, or `nullptr`.

Returns
  Success or failure.

Exceptions

  Glib::Error |

## ◆ handshake_async() [1/2]

void Gio::TlsConnection::handshake_async | ( | const SlotAsyncReady& | slot,
|  | const Glib::RefPtr< Cancellable >& | cancellable,
|  | int | io_priority = `Glib::PRIORITY_DEFAULT`
| ) |  |

Asynchronously performs a TLS handshake on conn.

See g_tls_connection_handshake() for more information.

Since glibmm 2.28:

Parameters

  io_priority | The [I/O priority][io-priority] of the request.
  cancellable | A Cancellable, or `nullptr`.
  slot | Callback to call when the handshake is complete.

## ◆ handshake_async() [2/2]

void Gio::TlsConnection::handshake_async | ( | const SlotAsyncReady& | slot,
|  | int | io_priority = `Glib::PRIORITY_DEFAULT`
| ) |  |

A handshake_async() convenience overload.

## ◆ handshake_async_vfunc()

virtual void Gio::TlsConnection::handshake_async_vfunc | ( | const SlotAsyncReady& | slot,
|  | const Glib::RefPtr< Cancellable >& | cancellable,
|  | int | io_priority
| ) |  |
| virtual

## ◆ handshake_finish()

bool Gio::TlsConnection::handshake_finish | ( | const Glib::RefPtr< AsyncResult >& | result | ) |

Finish an asynchronous TLS handshake operation.

See g_tls_connection_handshake() for more information.

Since glibmm 2.28:

Parameters

  result | A AsyncResult.

Returns
  `true` on success, `false` on failure, in which case error will be set.

Exceptions

  Glib::Error |

## ◆ handshake_finish_vfunc()

virtual bool Gio::TlsConnection::handshake_finish_vfunc | ( | const Glib::RefPtr< AsyncResult >& | result | ) |
| virtual

Exceptions

  Glib::Error. |

## ◆ handshake_vfunc()

virtual bool Gio::TlsConnection::handshake_vfunc | ( | const Glib::RefPtr< Cancellable >& | cancellable | ) |
| virtual

Exceptions

  Glib::Error. |

## ◆ on_accept_certificate()

virtual bool Gio::TlsConnection::on_accept_certificate | ( | const Glib::RefPtr< const TlsCertificate >& | peer_cert,
|  | TlsCertificateFlags | errors
| ) |  |
| protectedvirtual

This is a default handler for the signal signal_accept_certificate().

## ◆ operator=()

TlsConnection& Gio::TlsConnection::operator= | ( | TlsConnection&& | src | ) |
| noexcept

## ◆ property_base_io_stream()

Glib::PropertyProxy_ReadOnly< Glib::RefPtr<IOStream> > Gio::TlsConnection::property_base_io_stream | ( |  | ) | const

The IOStream that the connection wraps.

The connection holds a reference to this stream, and may run operations on the stream from other threads throughout its lifetime. Consequently, after the IOStream has been constructed, application code may only run its own operations on this stream when no IOStream operations are running.

Since glibmm 2.28:

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_certificate() [1/2]

Glib::PropertyProxy< Glib::RefPtr<TlsCertificate> > Gio::TlsConnection::property_certificate | ( |  | ) |

The connection's certificate; see g_tls_connection_set_certificate().

Since glibmm 2.28:

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_certificate() [2/2]

Glib::PropertyProxy_ReadOnly< Glib::RefPtr<TlsCertificate> > Gio::TlsConnection::property_certificate | ( |  | ) | const

The connection's certificate; see g_tls_connection_set_certificate().

Since glibmm 2.28:

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_database() [1/2]

Glib::PropertyProxy< Glib::RefPtr<TlsDatabase> > Gio::TlsConnection::property_database | ( |  | ) |

The certificate database to use when verifying this TLS connection.

If no certificate database is set, then the default database will be used. See g_tls_backend_get_default_database().

Since glibmm 2.30:

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_database() [2/2]

Glib::PropertyProxy_ReadOnly< Glib::RefPtr<TlsDatabase> > Gio::TlsConnection::property_database | ( |  | ) | const

The certificate database to use when verifying this TLS connection.

If no certificate database is set, then the default database will be used. See g_tls_backend_get_default_database().

Since glibmm 2.30:

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_interaction() [1/2]

Glib::PropertyProxy< Glib::RefPtr<TlsInteraction> > Gio::TlsConnection::property_interaction | ( |  | ) |

A TlsInteraction object to be used when the connection or certificate database need to interact with the user.

This will be used to prompt the user for passwords where necessary.

Since glibmm 2.30:

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_interaction() [2/2]

Glib::PropertyProxy_ReadOnly< Glib::RefPtr<TlsInteraction> > Gio::TlsConnection::property_interaction | ( |  | ) | const

A TlsInteraction object to be used when the connection or certificate database need to interact with the user.

This will be used to prompt the user for passwords where necessary.

Since glibmm 2.30:

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_peer_certificate()

Glib::PropertyProxy_ReadOnly< Glib::RefPtr<TlsCertificate> > Gio::TlsConnection::property_peer_certificate | ( |  | ) | const

The connection's peer's certificate, after the TLS handshake has completed and the certificate has been accepted.

Note in particular that this is not yet set during the emission of TlsConnection::signal_accept_certificate().

(You can watch for a Object::signal_notify() signal on this property to detect when a handshake has occurred.)

Since glibmm 2.28:

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_peer_certificate_errors()

Glib::PropertyProxy_ReadOnly< TlsCertificateFlags > Gio::TlsConnection::property_peer_certificate_errors | ( |  | ) | const

The errors noticed-and-ignored while verifying TlsConnection::property_peer_certificate().

Normally this should be 0, but it may not be if TlsClientConnection::property_validation_flags() is not TLS_CERTIFICATE_VALIDATE_ALL, or if TlsConnection::signal_accept_certificate() overrode the default behavior.

Since glibmm 2.28:

Default value: 0

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_rehandshake_mode() [1/2]

Glib::PropertyProxy< TlsRehandshakeMode > Gio::TlsConnection::property_rehandshake_mode | ( |  | ) |

The rehandshaking mode.

See g_tls_connection_set_rehandshake_mode().

Since glibmm 2.28:

Deprecated:
  Changing the rehandshake mode is no longer required for compatibility. Also, rehandshaking has been removed from the TLS protocol in TLS 1.3.

Default value: TLS_REHANDSHAKE_SAFELY

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_rehandshake_mode() [2/2]

Glib::PropertyProxy_ReadOnly< TlsRehandshakeMode > Gio::TlsConnection::property_rehandshake_mode | ( |  | ) | const

The rehandshaking mode.

See g_tls_connection_set_rehandshake_mode().

Since glibmm 2.28:

Deprecated:
  Changing the rehandshake mode is no longer required for compatibility. Also, rehandshaking has been removed from the TLS protocol in TLS 1.3.

Default value: TLS_REHANDSHAKE_SAFELY

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_require_close_notify() [1/2]

Glib::PropertyProxy< bool > Gio::TlsConnection::property_require_close_notify | ( |  | ) |

Whether or not proper TLS close notification is required.

See g_tls_connection_set_require_close_notify().

Since glibmm 2.28:

Default value: `true`

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_require_close_notify() [2/2]

Glib::PropertyProxy_ReadOnly< bool > Gio::TlsConnection::property_require_close_notify | ( |  | ) | const

Whether or not proper TLS close notification is required.

See g_tls_connection_set_require_close_notify().

Since glibmm 2.28:

Default value: `true`

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_use_system_certdb() [1/2]

Glib::PropertyProxy< bool > Gio::TlsConnection::property_use_system_certdb | ( |  | ) |

Whether or not the system certificate database will be used to verify peer certificates.

See g_tls_connection_set_use_system_certdb().

Deprecated: 2.30: Use GTlsConnection:database instead

Deprecated:
  Use property_database() instead.

Default value: `true`

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_use_system_certdb() [2/2]

Glib::PropertyProxy_ReadOnly< bool > Gio::TlsConnection::property_use_system_certdb | ( |  | ) | const

Whether or not the system certificate database will be used to verify peer certificates.

See g_tls_connection_set_use_system_certdb().

Deprecated: 2.30: Use GTlsConnection:database instead

Deprecated:
  Use property_database() instead.

Default value: `true`

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ set_certificate()

void Gio::TlsConnection::set_certificate | ( | const Glib::RefPtr< TlsCertificate >& | certificate | ) |

This sets the certificate that conn will present to its peer during the TLS handshake.

For a TlsServerConnection, it is mandatory to set this, and that will normally be done at construct time.

For a TlsClientConnection, this is optional. If a handshake fails with TLS_ERROR_CERTIFICATE_REQUIRED, that means that the server requires a certificate, and if you try connecting again, you should call this method first. You can call g_tls_client_connection_get_accepted_cas() on the failed connection to get a list of Certificate Authorities that the server will accept certificates from.

(It is also possible that a server will allow the connection with or without a certificate; in that case, if you don't provide a certificate, you can tell that the server requested one by the fact that g_tls_client_connection_get_accepted_cas() will return non-`nullptr`.)

Since glibmm 2.28:

Parameters

  certificate | The certificate to use for conn.

## ◆ set_database()

void Gio::TlsConnection::set_database | ( | const Glib::RefPtr< TlsDatabase >& | database | ) |

Sets the certificate database that is used to verify peer certificates.

This is set to the default database by default. See g_tls_backend_get_default_database(). If set to `nullptr`, then peer certificate validation will always set the TLS_CERTIFICATE_UNKNOWN_CA error (meaning TlsConnection::signal_accept_certificate() will always be emitted on client-side connections, unless that bit is not set in TlsClientConnection::property_validation_flags()).

Since glibmm 2.30:

Parameters

  database | A TlsDatabase.

## ◆ set_interaction()

void Gio::TlsConnection::set_interaction | ( | const Glib::RefPtr< TlsInteraction >& | interaction | ) |

Set the object that will be used to interact with the user.

It will be used for things like prompting the user for passwords.

The interaction argument will normally be a derived subclass of TlsInteraction. `nullptr` can also be provided if no user interaction should occur for this connection.

Since glibmm 2.30:

Parameters

  interaction | An interaction object, or `nullptr`.

## ◆ set_rehandshake_mode()

void Gio::TlsConnection::set_rehandshake_mode | ( | TlsRehandshakeMode | mode | ) |

Sets how conn behaves with respect to rehandshaking requests, when TLS 1.2 or older is in use.

TLS_REHANDSHAKE_NEVER means that it will never agree to rehandshake after the initial handshake is complete. (For a client, this means it will refuse rehandshake requests from the server, and for a server, this means it will close the connection with an error if the client attempts to rehandshake.)

TLS_REHANDSHAKE_SAFELY means that the connection will allow a rehandshake only if the other end of the connection supports the TLS `renegotiation_info` extension. This is the default behavior, but means that rehandshaking will not work against older implementations that do not support that extension.

TLS_REHANDSHAKE_UNSAFELY means that the connection will allow rehandshaking even without the `renegotiation_info` extension. On the server side in particular, this is not recommended, since it leaves the server open to certain attacks. However, this mode is necessary if you need to allow renegotiation with older client software.

Since glibmm 2.28:

Deprecated: 2.60. Changing the rehandshake mode is no longer required for compatibility. Also, rehandshaking has been removed from the TLS protocol in TLS 1.3.

Deprecated:
  Changing the rehandshake mode is no longer required for compatibility. Also, rehandshaking has been removed from the TLS protocol in TLS 1.3.

Parameters

  mode | The rehandshaking mode.

## ◆ set_require_close_notify()

void Gio::TlsConnection::set_require_close_notify | ( | bool | require_close_notify = `true` | ) |

Sets whether or not conn expects a proper TLS close notification before the connection is closed.

If this is `true` (the default), then conn will expect to receive a TLS close notification from its peer before the connection is closed, and will return a TLS_ERROR_EOF error if the connection is closed without proper notification (since this may indicate a network error, or man-in-the-middle attack).

In some protocols, the application will know whether or not the connection was closed cleanly based on application-level data (because the application-level data includes a length field, or is somehow self-delimiting); in this case, the close notify is redundant and sometimes omitted. (TLS 1.1 explicitly allows this; in TLS 1.0 it is technically an error, but often done anyway.) You can use g_tls_connection_set_require_close_notify() to tell conn to allow an "unannounced" connection close, in which case the close will show up as a 0-length read, as in a non-TLS SocketConnection, and it is up to the application to check that the data has been fully received.

Note that this only affects the behavior when the peer closes the connection; when the application calls g_io_stream_close() itself on conn, this will send a close notification regardless of the setting of this property. If you explicitly want to do an unclean close, you can close conn's TlsConnection::property_base_io_stream() rather than closing conn itself, but note that this may only be done when no other operations are pending on conn or the base I/O stream.

Since glibmm 2.28:

Parameters

  require_close_notify | Whether or not to require close notification.

## ◆ set_use_system_certdb()

void Gio::TlsConnection::set_use_system_certdb | ( | bool | use_system_certdb = `true` | ) |

Sets whether conn uses the system certificate database to verify peer certificates.

This is `true` by default. If set to `false`, then peer certificate validation will always set the TLS_CERTIFICATE_UNKNOWN_CA error (meaning TlsConnection::signal_accept_certificate() will always be emitted on client-side connections, unless that bit is not set in TlsClientConnection::property_validation_flags()).

Deprecated: 2.30: Use g_tls_connection_set_database() instead

Deprecated:
  Use set_database() instead.

Parameters

  use_system_certdb | Whether to use the system certificate database.

## ◆ signal_accept_certificate()

Glib::SignalProxy< bool,const Glib::RefPtr<const TlsCertificate>&,TlsCertificateFlags > Gio::TlsConnection::signal_accept_certificate | ( |  | ) |

Slot Prototype:
  `bool on_my_accept_certificate(const Glib::RefPtr<const TlsCertificate>& peer_cert, TlsCertificateFlags errors)`

Flags: Run Last

Emitted during the TLS handshake after the peer certificate has been received. You can examine peer_cert's certification path by calling g_tls_certificate_get_issuer() on it.

For a client-side connection, peer_cert is the server's certificate, and the signal will only be emitted if the certificate was not acceptable according to conn's TlsClientConnection::property_validation()_flags. If you would like the certificate to be accepted despite errors, return `true` from the signal handler. Otherwise, if no handler accepts the certificate, the handshake will fail with TLS_ERROR_BAD_CERTIFICATE.

For a server-side connection, peer_cert is the certificate presented by the client, if this was requested via the server's TlsServerConnection::property_authentication()_mode. On the server side, the signal is always emitted when the client presents a certificate, and the certificate will only be accepted if a handler returns `true`.

Note that if this signal is emitted as part of asynchronous I/O in the main thread, then you should not attempt to interact with the user before returning from the signal handler. If you want to let the user decide whether or not to accept the certificate, you would have to return `false` from the signal handler on the first attempt, and then after the connection attempt returns a TLS_ERROR_BAD_CERTIFICATE, you can interact with the user, and if the user decides to accept the certificate, remember that fact, create a new connection, and return `true` from the signal handler the next time.

If you are doing I/O in another thread, you do not need to worry about this, and can simply block in the signal handler until the UI thread returns an answer.

Since glibmm 2.28:

Parameters

  peer_cert | The peer's TlsCertificate.
  errors | The problems with peer_cert.

Returns
  `true` to accept peer_cert (which will also immediately end the signal emission). `false` to allow the signal emission to continue, which will cause the handshake to fail if no one else overrides it.

## Friends And Related Function Documentation

## ◆ wrap()

Glib::RefPtr< Gio::TlsConnection > wrap | ( | GTlsConnection * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.